/******************************************************************************
 *    ccolor.h
 *
 *    This file is part of CColor Converter
 *    Copyright (C) 2002 Tom N Harris
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/

typedef struct RIFFPal
{
	DWORD riffsig;
	DWORD rifflength;
	DWORD psig1;
	DWORD psig2;
	DWORD length;
} RIFFPal;

class CColor
{
	HWND gHWND;
	COLORREF gColor;
	HPALETTE gCTable;
	int gRGBMode, gHSVorHSLMode, gHueMode, gHuePercent;
	bool gUpdating;

	//bool setColorRGB(ccolor_t *color, bool percent, int excl);
	//bool setColorHSL(ccolor_t *color, bool percent, int excl);

	void UpdateDialog(int excl=0);
	COLORREF hsv_to_rgb(WORD h, WORD s, WORD v);
	void rgb_to_hsv(COLORREF rgb, WORD *h, WORD *s, WORD *v);

  public:
	~CColor();
	CColor();
	CColor(HWND h);
	CColor(HWND h, COLORREF rgb);
//	CColor(HWND h, DWORD r, DWORD g, DWORD b) { CColor(h, RGB(r,g,b)); }

	COLORREF getColor() { return gColor; }
	HPALETTE getColorTable() { return gCTable; }

	void setRGBMode(int m) 
		{ gRGBMode = m; UpdateDialog(); }
	void setHSVorHSLMode(int m) 
		{ gHSVorHSLMode = m; UpdateDialog(); }
	void setHueMode(int m) 
		{ gHueMode = m; UpdateDialog(); }
	void setHuePercent(int m) 
		{ gHuePercent = m; SetDlgItemText(gHWND, TEXT_PERCENT_HUE, m ? "%" : ""); UpdateDialog(); }

	bool setColorTable(HPALETTE pal);
	bool setColorTableIndex(DWORD i);
	bool setColorRGB(COLORREF color, int excl) 
		{ gColor = color; UpdateDialog(excl); return true; }
	bool setColorHSV(DWORD h, DOUBLE s, DOUBLE v, int excl);
	bool setColorHLS(DWORD h, DOUBLE s, DOUBLE v, int excl);
	
	bool update(int field);
};
